
JSB.newAddon = function (mainPath) {
  JSB.require('webviewController');
  var temSender;
  var MNNetworkClass = JSB.defineClass(
    'MNNetwork : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.appInstance = Application.sharedInstance();
        self.addonController = networkController.new();
        self.addonController.mainPath = mainPath;
        self.isNewWindow = false;
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        // Application.sharedInstance().showHUD(self.addonController.appearOnNewExcerpt,self.window,2)

        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          // try {
          //   self.appInstance.studyController(self.window).view.sendSubviewToBack(self.addonController.view)
            
          // } catch (error) {
          //   Application.sharedInstance().showHUD(error,self.window,2)
            
          // }
          self.addonController.view.hidden = true;
          self.addonController.notebookid = notebookid
          // self.addonController.webview.loadRequest(
          //   NSURLRequest.requestWithURL(NSURL.URLWithString(self.addonController.homePageURL))
          // );

          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt');

            self.addonController.goBackButton.hidden = true
            self.addonController.goForwardButton.hidden = true
            self.addonController.view.frame = { x: 50, y: 10, width: 500, height: 500 }
            self.addonController.webview.frame = { x: 50, y: 10, width: 500, height: 500 }
            self.addonController.currentFrame = { x: 50, y: 10, width: 500, height: 500 }
          }
          if (dynamic !== undefined) {
            self.addonController.dynamic = dynamic
          }
          self.customLayoutAddonController();
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
      },

      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        // self.addonController.homePage()
        self.watchMode = false;
        self.textSelected = '';
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ClosePopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ProcessNewExcerpt');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            let height = studyFrame.height-10;
            let splitLine = getSplitLine()
            switch (self.addonController.customMode) {
              case "left":
                self.addonController.view.frame = { x: 40, y: 10, width: splitLine - 45, height: height }
                break;
              case "left13":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width / 3. + 40, height: height}
                break;
              case "right":
                self.addonController.view.frame = { x: splitLine + 5, y: 10, width: studyFrame.width - splitLine - 45, height: height }
                break;
              case "right13":
                self.addonController.view.frame = { x: studyFrame.width * 2 / 3. - 40, y: 10, width: studyFrame.width / 3., height: height }
                break;
              case "full":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width - 80, height: height }
                break;
              default:
                break;
            }
            self.addonController.webview.frame = self.addonController.view.bounds
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
      },

      queryAddonCommandStatus: function () {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: self.watchMode
          };
        } else {
          return null;
        }
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
          //  Application.sharedInstance().showHUD(sender.userInfo.winRect, self.window, 2);

        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        isOnSelection = true
        self.textSelected = encodeURIComponent(sender.userInfo.documentController.selectionText.replaceAll('/', '\\/'));
        self.addonController.selectedText = self.textSelected
        if (self.isNewWindow) {
          self.newWindowController.selectedText = self.textSelected
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);

          if (self.isNewWindow) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (self.isNewWindow) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        //watch mode

        // var text = sender.userInfo.documentController.selectionText;
        if (self.textSelected && self.textSelected.length) {
          self.addonController.search(self.textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
        }
      },
      onProcessNewExcerpt:function (sender) {
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        let note = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        // Application.sharedInstance().showHUD("color: "+note.colorIndex,self.window,5)
        if (self.addonController.processNewExcerptColor !== -1 && note.colorIndex !== self.addonController.processNewExcerptColor) {
          return
        }
        if (self.addonController.appearOnNewExcerpt && self.textSelected && self.textSelected.length) {
          self.addonController.shouldCopy = self.addonController.autoCopy
          self.addonController.shouldComment = self.addonController.autoComment
          self.addonController.currentNoteId = sender.userInfo.noteid
          self.addonController.search(self.textSelected);
          if (self.addonController.autoDynamic) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.addonController.webview.hidden = false
        }
        // self.layoutAddonController(temSender)
        // if (watchMode) {
        //   self.addonController.view.hidden = true
        // }
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        // Application.sharedInstance().showHUD(frameText,self.window,5)
        let currentNoteId = sender.userInfo.note.noteId
        // Application.sharedInstance().showHUD(self.addonController.watchMode,self.window,2)
        let note = Database.sharedInstance().getNoteById(sender.userInfo.note.noteId)
        // Application.sharedInstance().showHUD(note,self.window,2)
        let text = note.excerptText
        if (!text || text.excerptText === "") {
          text = note.noteTitle
        }
        self.textSelected = encodeURIComponent(text.replaceAll('/', '\\/'))
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))

        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        if (self.isNewWindow) {
          self.newWindowController.selectedText = self.textSelected
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          if (self.isNewWindow) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (self.isNewWindow) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        if (self.textSelected && self.textSelected.length) {
          self.addonController.search(self.textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
        }
        // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
      },
      toggleAddon:function (sender) {
        let docMapSplitMode = self.appInstance.studyController(self.window).docMapSplitMode
          // Application.sharedInstance().showHUD(self.appInstance.studyController(self.window).view.subviews, self.window, 5)
        // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.window).view.subviews
          let focusNote
          if (docMapSplitMode===0) {
            focusNote = self.appInstance.studyController(self.window).notebookController.focusNote
          }else{
            focusNote = self.appInstance.studyController(self.window).readerController.documentControllers[0].focusNote
          }

          if (focusNote) {
            self.addonController.htmlMode = true
            let linkedNotes = focusNote.linkedNotes
            let title = focusNote.noteTitle?focusNote.noteTitle:"..."
            let excerpt = focusNote.excerptText?focusNote.excerptText:""
            let noteColorHexes = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
            let theme = self.appInstance.currentTheme
            let themeHtml = `      
              body{
                -webkit-text-fill-color: rgb(0, 0, 0);
              }`
            if (theme === "Gray") {
              noteColorHexes = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
              themeHtml = `      
              body{
                background-color: #414141;
                -webkit-text-fill-color: rgb(255, 255, 255);
              }`
            }else if (theme === "Dark") {
              noteColorHexes = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
              themeHtml = `      
              body{
                background-color: #121212;
                -webkit-text-fill-color: rgb(233, 232, 232);
              }`
            }
            let nodesHtml = linkedNotes.map((node)=>{
              let nodeNote = Database.sharedInstance().getNoteById(node.noteid)
              let color = noteColorHexes[nodeNote.colorIndex]
              let excerpt = nodeNote.excerptText?nodeNote.excerptText:""
              let label = nodeNote.noteTitle?nodeNote.noteTitle:nodeNote.excerptText
              if (nodeNote.excerptPic) {
                let imageData = Database.sharedInstance().getMediaByHash(nodeNote.excerptPic.paint)
                excerpt = `<img width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`
                label = nodeNote.noteTitle?nodeNote.noteTitle:"image"
              }
              return `{ 
                id: "${node.noteid}", 
                label: "${label}", 
                title:preTitle('<div class="linkedNode" style="border: 3px solid ${color}"><div class="head" style="background-color:${color}"><div class="title">${nodeNote.noteTitle?nodeNote.noteTitle:"..."}</div></div><p class="excerpt">${excerpt}</p><div class="tail"></div></div>'), 
                color:"${color}",
                shape:"box",
                widthConstraint:{maximum:200}
              }`
            })
            .concat(`{ 
              id: "${focusNote.noteid}", 
              label: "${focusNote.noteTitle?focusNote.noteTitle:focusNote.excerptText}", 
              color:"${noteColorHexes[focusNote.colorIndex]}",
              shape:"box",
              borderWidth:"3",
              widthConstraint:{maximum:200}
            }`)
            .join(",")
            let edgesHtml = linkedNotes.map((node)=>{
              return `{ from: "${node.noteid}", to: "${focusNote.noteid}"}`
            })
            .join(",")
            // let comments = focusNote.comments.map(comment=>{
            // // Application.sharedInstance().showHUD(comment.type, self.window, 2)
            //   if (comment.type === "TextNote") {
            //     return `<div class="comment">${comment.text}</div>`
            //   }else if (comment.type === "PaintNote") {
            //     let commentImage = Database.sharedInstance().getMediaByHash(comment.paint)
            //     return `<img width="100%" src="data:image/jpeg;base64,${commentImage.base64Encoding()}"/>`
            //   }else{
            //     return ""
            //   }
            // }).join("\n")
            let html = `
<html>
<head>
    <script type="text/javascript" src="https://unpkg.com/vis-network/standalone/umd/vis-network.min.js"></script>

    <style type="text/css">
        #mynetwork {
            width: 100%;
            height: 100%;
            border: 1px solid white;
        }
        .linkedNode {
          width: 100%-5px;
          min-width: 200px;
          max-width: 400px;
          white-space: normal;
          border-radius: 10px 10px 10px 10px;
          font-size: large;
        }
        .head {
          border-radius: 6px 6px 0px 0px;
          line-height: 35px;
        }
        .title {
          padding-left: 10px;
        }
        .excerpt {
          white-space: pre-line;
          padding-left: 10px;
        }
        .tail {
          height: 10px;
        }
    </style>
</head>
<body>
<div id="mynetwork"></div>

<script type="text/javascript">
    // 创建节点数据数组
    var nodes = new vis.DataSet([
      ${nodesHtml}
    ]);

    // 创建边数据数组
    var edges = new vis.DataSet([
      ${edgesHtml}
    ]);

    // 获取容器
    var container = document.getElementById('mynetwork');

    // 将数据赋值给vis 数据格式化器
    var data = {
        nodes: nodes,
        edges: edges
    };
    var options = {};

    // 初始化关系图
    var network = new vis.Network(container, data, options);
    var dateNow = Date.now()
    network.on('click',function(properties){
      console.log(properties)
      if (Date.now()-dateNow < 500 && properties.nodes.length) {
        window.location.assign("marginnote3app://note/"+properties.nodes[0]);//在當前界面打開鏈接
      }
      dateNow = Date.now()
    
    })
    function preTitle(text) {
      const container = document.createElement("pre");
      container.innerHTML = text;
      return container;
    }
</script>
</body>
</html>

`
            self.addonController.webview.loadHTMLStringBaseURL(html)
            self.addonController.view.hidden = false
            self.addonController.webview.hidden = false

          }else{
            self.appInstance.showHUD("No note selected", self.window, 2)
          }
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNNetworkClass.prototype.layoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 500 :500, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNNetworkClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 500 : 500, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  return MNNetworkClass;
};